#include <Wire.h>  //LCD Display libraries
#include <LiquidCrystal_I2C.h>

// Set the pins on the I2C chip used for LCD connections:
//                    addr, en,rw,rs,d4,d5,d6,d7,bl,blpol
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  // 設定 LCD I2C 位址

int VCC2 = 13;   //pseudo Vcc
int buttonPin = 2;   //button
int trigPin = 11;    //trigger
int echoPin = 10;   //echo
int buttonState = LOW;
int delay_time = 500;
String unit="";
unsigned long duration;
float cm, inches, distance;

void setup() {
  pinMode(VCC2,OUTPUT);//define a digital pin as output
  digitalWrite(VCC2, HIGH);// set the above pin as HIGH so it acts as 5V

  Serial.begin(9600);  // 用於手動輸入文字
  lcd.begin(16, 2);      // 初始化 LCD，一行 16 的字元，共 2 行，預設開啟背光
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode(buttonPin,INPUT);
}

void loop() {
//clear off
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);

// create a pulse to the trigger
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10); // the trigger pulse is 10 microsecond apart
  digitalWrite(trigPin, LOW);

//listen to echo pin and calculate the distance 
  duration = pulseIn(echoPin, HIGH); //measuring duration of pulse
  cm = (duration/2.0)*0.034;
  inches = cm*0.393700787;

if (digitalRead(buttonPin)==HIGH&&buttonState==LOW){
  lcd_display(inches, "(inches)");
  buttonState=HIGH;
  delay(delay_time);     
}
else if (digitalRead(buttonPin)==HIGH&&buttonState==HIGH){
  lcd_display(cm, "(cm)");
  buttonState=LOW;  
  delay(delay_time);    
}

else if (digitalRead(buttonPin)==LOW&&buttonState==HIGH){
  lcd_display(inches, "(inches)");
  buttonState=HIGH;
  delay(delay_time);  
}

else if (digitalRead(buttonPin)==LOW&&buttonState==LOW){
  lcd_display(cm, "(cm)");
  buttonState=LOW;  
  delay(delay_time);
}

}

void lcd_display(float distance, String unit){
//write to lcd
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Distance");
  lcd.print(unit);  
  lcd.setCursor(0,1);  
  lcd.print(distance,1);
}
